/***************************************************************************/
/*           SPRITES EN EL MODO VGA DE 640 X 480 DE 16 COLORES             */
/*                                                                         */
/*      por: Jos Antonio Acedo Martn-Grande, miembro de "GOLDY GAMES"    */
/*                                                                         */
/*                     TEL: 6 11 72 71 (MADRID pref. 91)                   */
/***************************************************************************/

#include <dos.h>                /*  cabeceras que hacen que se incluyan    */
#include <conio.h>              /*  durante el proceso de compilado        */
#include <stdio.h>              /*  las funciones que el programa utilize  */
#include <stdlib.h>

/******************************* DEFINICIONES ******************************/

#define ALFANUMERICO  3         /*  el compilador cambia la palabra por    */
#define GRAFICO      18         /*  su nmero en el proceso de compilacin */

/*********************** DECLARACIONES DE FUNCIONES ************************/

void asigna_modo_video(char);
void asigna_memoria(void);
void libera_memoria(void);
void lee_dibujo(const char *);
void descomprime_dibujo(char *);
void asigna_rgb(char *);

void BORRA_ZONA_PANTALLA(void);
void DIBUJA_SPRITE     (char *, int, int, int, int, int, int);
void DIBUJA_SPRITE_MASK(char *, int, int, int, int, int, int, int, int);
void VUELCA_PANTALLA(void);

/*************************** VARIABLES GLOBALES ****************************/

	 char *dir_carga_dibujo;
	 char *dir_dibujo_1;
const    char  dibujo_1[]  = "sprites.pcx";
const	 int   colores[16] = { 0, 1, 2, 3, 4, 5, 20, 7, 56, 57, 58, 59, 60, 61, 62, 63 };
	 FILE *handle_dibujo;

/************************** COMIENZO DEL LISTADO ***************************/

void main(void)
{
	asigna_memoria();
	asigna_modo_video(GRAFICO);
	lee_dibujo(dibujo_1);
	descomprime_dibujo(dir_dibujo_1);

	  BORRA_ZONA_PANTALLA();
	  DIBUJA_SPRITE     (dir_dibujo_1, 12,0,       34,40, 11,47);
	  VUELCA_PANTALLA();
	  getch();
	  DIBUJA_SPRITE_MASK(dir_dibujo_1,  0,0, 0,70, 34, 0, 12,70);
	  VUELCA_PANTALLA();
	  getch();

	asigna_modo_video(ALFANUMERICO);
	libera_memoria();
}

void asigna_modo_video(char modo)
{
	union REGS r;

        r.h.al = modo;
        r.h.ah = 0;
        int86(16, &r, &r);
}

void asigna_memoria(void)
{
	if((dir_carga_dibujo=(char *)malloc( 65000 ))==NULL)
	{
	  asigna_modo_video(ALFANUMERICO);
	  printf("No hay suficiente memoria. Libera programas residentes.");
	  exit(1);
	}
	if((dir_dibujo_1    =(char *)malloc(80*200*4))==NULL)
	{
	  asigna_modo_video(ALFANUMERICO);
	  printf("No hay suficiente memoria. Libera programas residentes.");
	  exit(1);
	}
}

void libera_memoria(void)
{
	free(dir_carga_dibujo);
	free(dir_dibujo_1);
}

void lee_dibujo(const char *dibujo)
{
	char *dir;

	if((handle_dibujo=fopen(dibujo, "rb"))==NULL)
	{
	  asigna_modo_video(ALFANUMERICO);
	  printf("No se encontr el dibujo solicitado.");
	  exit(1);
	}

	dir=dir_carga_dibujo;
	while(!feof(handle_dibujo)) { *dir++=getc(handle_dibujo); }

	if(fclose(handle_dibujo)!=NULL)
	{
          asigna_modo_video(ALFANUMERICO);
          printf("No se pudo cerrar el archivo.");
          exit(1);
        }
}

void descomprime_dibujo(char *dir_escritura)
{
  unsigned char  byte;
	   char *dir_lectura;
	   int  *dir_carga, columnas, filas, contador;

  dir_lectura= 128 + (char *)dir_carga_dibujo;
  dir_carga  =(int *)dir_carga_dibujo;

  for(filas=*(dir_carga+5); filas>=0; filas--)
  {
    columnas=((*(dir_carga+4))+1)/2;
    while(columnas>0)
    {
      byte=*dir_lectura++;
      if(byte<=0xC0)
      {
	*dir_escritura++=byte; columnas--;
      }
      else
      {
	contador=byte&0x3F; byte=*dir_lectura++;
	for(; contador>0; contador--) { *dir_escritura++=byte; columnas--; }
      }
    }
  }
  asigna_rgb(dir_carga_dibujo);
}

void asigna_rgb(char *dir_dibujo)
{
	struct   SREGS  seg;
	union     REGS  ent, sal;
		  int   n;
	long      int   dir;
		  char *dir_col;

	dir_col=dir_dibujo+16;                    /* divide entre 4 */
	for(n=16*3; n>0; n--)                     /* los colores    */
	{
	  *dir_col=(*dir_col) >> 2; dir_col++;
	}

	dir   =(long)(dir_dibujo+16);             /* obtiene el segmento     */
	seg.es=(int )(dir >> 16);                 /* donde estan los colores */

	for(n=0; n<16; n++)
	{
	  ent.h.al = 18;
	  ent.h.ah = 16;
	  ent.x.bx = colores[n];
	  ent.x.cx =  1;
	  ent.x.dx = (int)dir;            /* offset de los colores            */
	  int86x(0x10, &ent, &sal, &seg); /* funcin para asignar los colores */
	  dir+=3;
	}
}
