'Este programa calcula la dinmica de la civilizacin Maya
SCREEN 12

'Significado de las constantes y variables
'alc:  Vida media de la poblacin
'alm:  Vida media de los monumentos
'ampc: Media de monumentos por persona
'c:    Poblacin
'cbr:  Tasa de natalidad
'cdr:  Tasa de mortalidad
'cfp:  Poblacin dedicada a la produccin de alimentos
'cmc:  Poblacin dedicada a construir monumentos
'cpc:  Construccin por persona
'dmpc: Monumentos demandados por persona
'fcmc: Fraccin de poblacin dedicada a construir monumentos
'fp:   Produccin de alimentos
'fpc:  Comida por persona
'ircmc:Indicador de la fraccin de poblacin dedicada a construir monumentos
'm:    Nmero de monumentos
'mcr:  Tasa de construccin de monumentos
'mdr:  Tasa de destruccin de monumentos
'mhl:  Nivel sanitario de la poblacin
'mpc:  Monumentos por persona
'rcmc: Fraccin de poblacin dedicada a construir monumentos
'tampc:Tiempo para promediar los monumentos por persona
'tcr:  Tiempo para cambiar la rcmc

'****************************
'Se asignan valores iniciales a las variables de las cuatro ecuaciones
'diferenciales
'Poblacin inicial
c = 4000000
'Nmero de monumentos inicial
m = 1000
'Fraccin de poblacin inicial dedicada a construir monumentos
rcmc = .25
'Media inicial de monumentos por persona
ampc = .00025
'****************************
'Se asignan valores a las constantes y variables de las ecuaciones
'Las constantes que empiezan por n corresponden a los valores normales de
'la variable que hay despus de la n
alm = 1000     'aos
nalc = 25      'aos
ncfp = 3300000 'personas
ncpc = .00025  'monumentos/persona
ncbr = .041    'personas/personas/ao
nfp = 9.2E+08  'kg/ao
nfpc = 230     'kg/persona/ao
nmpc = .00025  'monumentos/persona
tampc = 20     'aos
tcr = 75       'aos

'Frecuencia con la que se calculan las ecuaciones diferenciales
f = .1

'Bucle principal
FOR t = 1 TO 550
        'Se calculan las variables auxiliares
        fcmc = rcmc / (rcmc + 1)
        cfp = c * (1 - fcmc)
        fp = cfp / ncfp
        fpc = fp * nfp / c
        mhl = fpc / nfpc
        alc = nalc * mhl
        cbr = c * ncbr
        cdr = c / alc
        cmc = c * fcmc
        cpc = ncpc * mhl
        mcr = cmc * cpc
        mdr = m / alm
        dmpc = nmpc * mhl
        ircmc = rcmc * ampc / dmpc
        mpc = m / c
        '********************
        'Primera ecuacin diferencial
        c = c + (cbr - cdr) * f
        IF c < 0 THEN c = 0: EXIT FOR
        '********************
        'Segunda ecuacin diferencial
        m = m + (mcr - mdr) * f
        '********************
        'Tercera ecuacin diferencial
        rcmc = rcmc + ((ircmc - rcmc) / tcr) * f
        '********************
        'Cuarta ecuacin diferencial
        ampc = ampc + ((mpc - ampc) / tampc) * f
       
        'Se imprimen las curvas
        LINE (1, 300)-(550, 300)
        LINE (1, 300)-(1, 100)
        PSET (t, 300 - c / 30000), 1
        PSET (t, 300 - m / 70), 2
NEXT
LOCATE 22, 2: PRINT "Poblacin final: "; INT(c)
LOCATE 23, 2: PRINT "Nmero de monumentos: "; INT(m)

